<?php namespace IFBB;

final class Sticky_Kit {

	// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

    public static function ifwp_plugins_loaded(){
        if(!defined('FL_BUILDER_VERSION')){
            return;
    	}
        add_filter('fl_builder_column_attributes' , [__CLASS__, 'fl_builder_column_attributes'], 10 , 2);
		add_filter('fl_builder_register_settings_form' , [__CLASS__, 'fl_builder_register_settings_form'], 10 , 2);
        add_filter('wp_enqueue_scripts' , [__CLASS__, 'wp_enqueue_scripts']);
    }

    // ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	//
	// public
	//
	// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

    public static function fl_builder_column_attributes($attrs, $col){
        if(!isset($col->settings->stick_in_parent)){
            return $attrs;
        }
		switch($col->settings->stick_in_parent){
			case 'column_group':
				$attrs['data-sticky_column'] = 'column_group';
				break;
			case 'column_group_nested':
				$attrs['data-sticky_column'] = 'column_group_nested';
				break;
			case 'row':
				$attrs['data-sticky_column'] = 'row';
				break;
		}
		if(!isset($col->settings->stick_in_parent_offset_top)){
            return $attrs;
        }
		$attrs['data-sticky_offset_top'] = $col->settings->stick_in_parent_offset_top;
		return $attrs;
    }

	// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

    public static function fl_builder_register_settings_form($form, $id){
		switch($id){
			case 'col':
				//$form['tabs']['advanced']['sections']['visibility']['fields']['stick_in_parent'] = [
				$form['tabs']['style']['sections']['general']['fields']['stick_in_parent'] = [
					'default' => '0',
					'label' => 'Stick in',
					'options' => [
						'none' => 'None',
						'column_group' => 'Column group',
						'column_group_nested' => 'Column group nested',
						'row' => 'Row',
					],
					'preview' => [
						'type' => 'none',
					],
					'toggle' => [
						'column_group' => [
							'fields' => ['stick_in_parent_offset_top'],
						],
						'column_group_nested' => [
							'fields' => ['stick_in_parent_offset_top'],
						],
						'row' => [
							'fields' => ['stick_in_parent_offset_top'],
						],
					],
					'type' => 'select',
				];
				//$form['tabs']['advanced']['sections']['visibility']['fields']['stick_in_parent_offset_top'] = [
				$form['tabs']['style']['sections']['general']['fields']['stick_in_parent_offset_top'] = [
					'default' => '0',
					'label' => 'Offset top',
					'placeholder' => '0',
					'preview' => [
						'type' => 'none',
					],
					'responsive' => false,
					'slider' => true,
					'type' => 'unit',
					'units' => ['px'],
				];
				return $form;
				break;
			default:
				return $form;
		}
    }

	// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

    public static function wp_enqueue_scripts(){
		if(isset($_GET['fl_builder'])){
			return;
		}
        wp_enqueue_script('sticky-kit', 'https://cdnjs.cloudflare.com/ajax/libs/sticky-kit/1.1.3/sticky-kit.min.js', ['jquery'], '1.1.3', true);
		ifwp_enqueue_asset('ifbb-sticky-kit', 'sticky-kit.js', ['sticky-kit']);
		wp_add_inline_script('ifbb-sticky-kit', 'ifbb_sticky_kit.load();');
    }

	// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

}
